﻿<?php
  class SchoolMember {
    private $_name;
    private $_age;

    //Define the constructor
    function __construct($name, $age) {
      $this->setName($name);
      $this->setAge($age);
      echo "A school member was initialized\n";
    }

    //Define the getter
    function getName() {
      return $this->_name;     
    }

    //Define the setter
    function setName($value) {
      if ($value != "" )
        $this->_name = $value;
      else
        throw new Exception("Name cannot be empty");
    }

    //Define the getter
    function getAge() {
      return $this->_age;     
    }

    //Define the setter
    function setAge($value) {
      if ($value > 0)
        $this->_age = $value;
      else
        throw new Exception("Age cannot be negative or zero");
    }  
  }

  class Teacher extends SchoolMember {
    private $_salary;  //This is an additional field for class Teacher

    //Define the constructor
    function __construct($name, $age, $salary) {
      parent::__construct($name, $age);
      $this->setSalary($salary); 
      echo "A teacher was initialized\n";
    }

    //Define the getter
    function getSalary() {
      return $this->_salary;     
    }

    //Define the setter
    function setSalary($value) {
      if ($value >= 0)
        $this->_salary = $value;
      else
        throw new Exception("Salary cannot be negative");
    }  
  }

  class Student extends SchoolMember {
    private $_grades = [];  //This is an additional field for class Student

    //Define the constructor
    function __construct($name, $age, $grades) {
      parent::__construct($name, $age);
      $this->setGrades($grades);
      echo "A student was initialized\n";
    }

    //Define the getter
    function getGrades() {
      return $this->_grades;     
    }

    //Define the setter
    function setGrades($values) {
      //$values here is an array. Check if negative grade exists in $values
      $negative_found = false;
      foreach ($values as $k => $v) {
        if ($v < 0)
          $negative_found = true;
      }

      if (!$negative_found)
        $this->_grades = $values;
      else
        throw new Exception("Grades cannot be negative");
    }
  }

  $teacher1 = new Teacher("Mr. John Scott", 43, 35000);
  $teacher2 = new Teacher("Mrs. Ann Carter", 5, 32000);

  $student1 = new Student("Mark Nelson", 14, [90, 95, 92]);
  $student2 = new Student("Mary Morgan", 13, [92, 97, 94]);

  echo $teacher1->getName(), "\n";
  echo $teacher1->getAge(), "\n";
  echo $teacher1->getSalary(), "\n";

  echo $student2->getName(), "\n";
  echo $student2->getAge(), "\n";
  foreach ($student2->getGrades() as $k => $grade) {
    echo $grade, "\n";
  }
?>
